#pragma once

#include "cstddef.hpp"

namespace ReVolta::Filesystem {

    /* Define the maximum amout of opened files in the system */
    /* TODO: Maybe to move it somewhere else - the platform file? */
    constexpr const size_t max_open_files { 5 };

    class file_descriptor {
    public:
        /* Constructs empty file descriptor */
        constexpr file_descriptor( void ) noexcept : m_value( empty_value ) {}

        size_t get( void ) const noexcept {
            return m_value;
        }

        bool is_empty( void ) noexcept {
            return ( m_value == empty_value );
        }

        /* TODO: Copy and move constructors shall appear here, or let them make generated by the compiler? */

    private:
        constexpr static size_t empty_value { max_open_files + 1 };

        /* Only the related filesystem functions like open()... may create file descritor */
        constexpr file_descriptor( size_t value ) noexcept : m_value( ( value <= max_open_files ) ? value : empty_value ) {}

        size_t m_value;
    };

}